/***************************************************************
 * Name:      checklistctrl.cpp
 * Purpose:   Code for the listctrl with checkbox
 * Author:    Jackie Team (jackie.team@gmail.com)
 * Created:   2007-11-26
 * Copyright: Jackie Team (http://musicorganizer.free.fr)
 * License: GNU GPL
 **************************************************************/

// Include XPM icons
#include "images/checked.xpm"
#include "images/unchecked.xpm"

#include "checklistctrl.h"

	/*
	 * wxCheckListCtrl
	 */

	IMPLEMENT_CLASS(wxCheckListCtrl, wxListCtrl)

	BEGIN_EVENT_TABLE(wxCheckListCtrl, wxListCtrl)
		EVT_MOUSE_EVENTS(wxCheckListCtrl::OnMouseEvent)
		//EVT_CHAR(wxCheckListCtrl::OnKeyDown)
	END_EVENT_TABLE()

	wxCheckListCtrl::wxCheckListCtrl(wxWindow* parent, wxWindowID id, const wxPoint& pt,
	const wxSize& sz, long style):
	wxListCtrl(parent, id, pt, sz, style)
	{
		LoadIcons();
        InsertColumn(0, _("Old name"));
        InsertColumn(1, _("New name"));
        InsertColumn(2, _("State"));
        SetColumnWidth(0, 360);
        SetColumnWidth(1, 360);
        SetColumnWidth(2, 70);
	}


	/// Load the icons
	bool wxCheckListCtrl::LoadIcons()
	{
		//FIXME : Manual delete need
		m_imageList = new wxImageList(16, 16, true);
		AssignImageList(m_imageList, wxIMAGE_LIST_SMALL);

		m_imageList->Add(wxIcon(checked_xpm));
		m_imageList->Add(wxIcon(unchecked_xpm));

		return true;
	}


	wxCheckListCtrl::~wxCheckListCtrl()
	{
	}


	/// Set the appropriate icon
	bool wxCheckListCtrl::SetIcon(long& item,int state)
	{
		bool l_ret = true;

		wxListItem l_item;
		l_item.SetId(item);
        	l_item.SetMask(wxLIST_MASK_IMAGE);
		GetItem(l_item);

		if ( state==-1 )  //on inverse l'etat courant
		{
			if ( l_item.GetImage() == 0 )
			{
				SetItemImage ( item, 1 );
			}
			else
			{
				SetItemImage ( item, 0 );
			}
		}
		else if ( state==0 )
		{
			SetItemImage ( item, 0 );
		}
		else
		{
			SetItemImage ( item, 1 );
		}
		return l_ret;
	}


	void wxCheckListCtrl::OnMouseEvent(wxMouseEvent& event)
	{
		int l_flags = 0;
		long l_subitem;
		long l_item = HitTest(wxPoint(event.GetX(), event.GetY()), l_flags, &l_subitem);

		if (event.LeftDown())
		{
			if (l_flags & wxLIST_HITTEST_ONITEMICON)
			{
				SetIcon(l_item);
			}
		}

		event.Skip();
	}


	void wxCheckListCtrl::OnKeyDown(wxKeyEvent& event)
	{
		int l_flags = 0;
		long l_subitem;
		long l_item = HitTest(wxPoint(event.GetX(), event.GetY()), l_flags, &l_subitem);

		if (event.GetKeyCode() == WXK_SPACE)
		{
			SetIcon(l_item);
		}
		else
		{
			event.Skip();
		}
	}

	bool wxCheckListCtrl::IsChecked(long item)
	{
		wxListItem l_item;
		l_item.SetId(item);
		l_item.SetMask(wxLIST_MASK_IMAGE);
		GetItem(l_item);
		if(l_item.GetImage() == 0)
			return true;
		else
			return false;
	}


